![Translate ACF fields with DeepL](https://repository-images.githubusercontent.com/687052699/720eb8b7-5e07-4938-82a5-8525323a0eab)


# Skelpo Translation for ACF
## Translate ACF fields with DeepL

Skelpo Translation for ACF is a WordPress plugin that provides easy translation and localization support for websites built using the Advanced Custom Fields (ACF) plugin. This tool allows you to manage translations for ACF fields, making your website content multilingual and accessible to a global audience. The plugin uses DeepL's translation services.

## Features

- **Simple Integration**: Skelpo Translation for ACF seamlessly integrates with the Advanced Custom Fields plugin, making it easy to translate your custom fields.
- **Multilingual Support**: Translate ACF fields and content into multiple languages, enhancing the accessibility of your WordPress site.
- **User-Friendly**: An intuitive user interface ensures that even non-technical users can manage translations effortlessly.
- **Performance**: Designed with performance in mind, Skelpo Translation for ACF won't slow down your website.

## Installation

1. Clone or download the repository.
2. Upload the `skelpo-translation-for-acf` directory to your WordPress site's `wp-content/plugins` directory.
3. Activate the plugin through the WordPress admin interface.

## Usage

1. Navigate to the WordPress dashboard.
2. Go to the page or post you want to translate.
3. Create a new translation of the page or post.
4. Use the side box to translate everything you see.
5. Save your changes.

## Contributing

We welcome contributions from the community. If you'd like to contribute to Skelpo Translation for ACF, please follow these guidelines:

- Fork the repository.
- Create a new branch for your feature or bug fix.
- Make your changes and commit them with descriptive commit messages.
- Create a pull request to the `main` branch of the original repository.

For more information, check out our [contribution guidelines](CONTRIBUTING.md).

## License

Skelpo Translation for ACF is licensed under the [GPL License](LICENSE). You are free to use, modify, and distribute this software according to the terms of the license.

## Support

If you encounter any issues or have questions about using Skelpo Translation for ACF, please open an issue on the [GitHub repository](https://github.com/skelpo/skelpo-translation-for-acf/issues).

## Credits

Skelpo Translation for ACF is developed and maintained by Skelpo Inc. & morepixel GmbH.

## Acknowledgments

Special thanks to the [Advanced Custom Fields](https://www.advancedcustomfields.com/) community for their inspiration and support.

We hope you find Skelpo Translation for ACF helpful for managing translations on your WordPress site! If you have any feedback or suggestions, feel free to reach out.
